\ ***** create a character buffer for lcd of AVR Butterfly  *****

hex heap e@      constant cur
    heap e@ 2 +  constant cbuf
    heap e@ 20 + heap e!                \ use allot in amforth 1.3.

: lcdcr ( -- ) 0 cur ! ;  lcdcr \ reset cursor.

: lcdemit ( c -- ) \ emits character into character buffer.
  cur @ 01f > if drop  \ cut rest 
  else cbuf cur @ + c!  cur @ 1+ cur ! then ;
    
: cnul ( -- ) \ clear character buffer.
  20 0 do 0 cbuf i + ! loop ;  

\ ---- testing -----

: dump ( adr u -- )  \ ram dump
  0 do
  cr dup i + . 
  dup i + c@ ff and dup . 20 emit emit  
  loop drop ;

: ccc  cur 25 dump ;

: keyin (  n "c" -- ) 
  lcdcr
  ." type n keys:"   0 do key dup emit lcdemit loop ;
  


\ finis




\ ----- commment -----

\ First cell is used as a pointer into buffer.

\ adr$00 --> curL
\ adr$01 --> curH

\ adr$02 --> cbuf
\ adr$03 --> cbuf 1+
\ ...
\ adr$1F --> cbuf 1F +  



\ todo:
\ lcdtype ( adr n -- ) \ type n characters from adr to LCD disply.
\ ticker if > 6 digits.
\ lcd. ( n -- ) \ print nummer to LCD display



