
\ some testing

hex

: bin 2 base ! ; 

: edump ( adr u -- )  \ eeprom dump
  0 do
  cr dup i + . 
  dup i + e@ ff and dup . 20 emit emit  
  loop drop ;

: dump ( adr u -- )  \ ram dump
  0 do
  cr dup i + . 
  dup i + c@ ff and dup . 20 emit emit  
  loop drop ;

: mem ( -- )
  cr ." eeprom vectors:"
  cr dp dup . ."  dp:" e@ .
  cr head dup . ."  head:" e@ .
  cr heap dup . ."  heap:" e@ .
  cr heap 2 + dup . ."  edp:" e@ .
  cr ." ram locations:"
  cr tib . ."  tib"
  cr hold . ."  hold"
  cr pad . ."  pad"
\   cr ibuf . ."  ibuf"
  cr cbuf . ."  cbuf"
  cr heap e@ . ."  start of free ram"
  ;
  
  
  
  
\ test character buffer

: ccc ( -- ) cbuf 20 dump ;

: keyin (  n "c" -- ) 
  lcdcr
  ." type n keys:"   0 do key dup emit lcdemit loop ;
  
: wait ( n -- ) 0 do 1ms loop ;

variable time   100 time !
: scroll ( n -- ) \ 
  time !
  initlcd clrlcd
  begin
  cbuf wlcd
  time @ 3 * wait
  13 0 do cbuf i + wlcd time @ wait loop
  time @ 3 * wait
  key? until ;

\ finis
