\ ***** write characters to lcd display of AVR Butterfly *****

: lcd? ( -- ) \ testing
  0 13 do cr ec i + dup . c@ . -1 +loop drop ;

: sget ( char -- seg ) \ convert character to segment code.
  dup 40 > if 5F and then  \ upper
  2A - seglist + i@ ;  \ beginning with: $2A='*'    
   
  \ key dup . 20 emit dup emit sget .  \ test
  \ seglist 1c + i@ .

\ fix amforth-1.2 "r@-bug" first!!
: cnib ( seg -- n0 n1 n2 n3 ) \ convert to nibbles.
  >r
  r@            0f and 
  r@  04 rshift 0f and
  r@  08 rshift 0f and
  r>  0C rshift 0f and ;
  

: lo! ( n0 n1 n2 n3 lcddr0 -- ) \ fit in even digits
  >r
  r@ 0F + c! 
  r@ 0A + c! 
  r@ 05 + c! 
  r>      c! ;
  
: hi! ( n0 n1 n2 n3 lcddr0 -- ) \ fit in odd digits

  >r

  4 lshift  r@ 0f + c@    or r@ 0f + c! 

  4 lshift  r@ 0a + c@    or r@ 0a + c! 

  4 lshift  r@ 05 + c@    or r@ 05 + c! 

  4 lshift  r@      c@ or r>         c! ;
  
: wlcd1 ( cbuf -- n0 n1 n2 n3 lcddr0 )
  dup c@ sget cnib ec ;

: wlcd ( adr -- ) \ write lcd data registers
  wlcd1     lo! 1+
  wlcd1     hi! 1+
  wlcd1 1+  lo! 1+
  wlcd1 1+  hi! 1+
  wlcd1 2 + lo! 1+
  wlcd1 2 + hi! drop ;


\ finis


\ ---- testing ----

: wait ( n -- ) 0 do 1ms loop ;

variable time   100 time !

: scroll ( n -- ) \ don't forget to initlcd
  time !
  begin
  cbuf wlcd
  time @ 3 * wait
  13 0 do cbuf i + wlcd time @ wait loop
  time @ 3 * wait
  key? until ;



: rrr ( n -- ) \ check r@
 >r 
 r@ . 
 r@ . 
 r@ .
 ."  r-from " r> .  ;  


\ end
