\ ***** control lcd of AVR Butterfly *****

    hex 

\ ' noop 3 intvector !  \ if some one turns on interupt! :-)

: initlcd ( -- ) \ init lcd control registers
  \ EF E7 c!   \ lcdccr: driver time 50%; contrast 3,35V
  E0 E7 c!   \ ... 2,60V is more clear
  07 E6 c!   \ lcdfrr: (ps=0 == 1/16, cd=7) --> 36,6 Hz
  77 E5 c!   \ lcdcrb: cs=0, 2b=1, mux=11==1/4 duty, pm=111==all
  C0 E4 c! ; \ lcdcra: en=1, ab=1, if=0, ie=0, bl=0=on


\ handling of control registers

: lcdoff ( -- ) \ disable LCD display.
  0 E4 c! ;    

: clrlcd ( -- ) \ clear LCD data registers top down.
  0 12 do 0 EC i + c! -1 +loop ;
  
: segon ( -- ) \ show segments.
  E4 c@ 0FE and E4 c! ;    

: segoff ( -- ) \ blank segments.
  E4 c@ 1 or E4 c! ; 
  
\ finis
