\ ***** lcd look-up table for AVR Butterfly ***** 

here \ start of lookup table --> ascii: 2A ;.

 0A51 ,  \  00 '*' (?)
 2A80 ,  \  01 '+'
 0000 ,  \  02 ',' (Not defined)
 0A00 ,  \  03 '-'
 0A51 ,  \  04 '.' Degree sign
 0000 ,  \  05 '/' (Not defined)
 5559 ,  \  06 '0'
 0118 ,  \  07 '1'
 1e11 ,  \  08 '2'
 1b11 ,  \  09 '3'
 0b50 ,  \  0A '4'
 1b41 ,  \  0B '5'
 1f41 ,  \  0C '6'
 0111 ,  \  0D '7'
 1f51 ,  \  0E '8'
 1b51 ,  \  0F '9'
 0000 ,  \  10 ':' (Not defined)
 0000 ,  \  11 ';' (Not defined)
 0000 ,  \  12 '<' (Not defined)
 0000 ,  \  13 '=' (Not defined)
 0000 ,  \  14 '>' (Not defined)
 0000 ,  \  15 '?' (Not defined)
 0000 ,  \  16 '@' (Not defined)
 0f51 ,  \  17 'A' (+ 'a')
 3991 ,  \  18 'B' (+ 'b')
 1441 ,  \  19 'C' (+ 'c')
 3191 ,  \  1A 'D' (+ 'd')
 1e41 ,  \  1B 'E' (+ 'e')
 0e41 ,  \  1C 'F' (+ 'f')
 1d41 ,  \  1D 'G' (+ 'g')
 0f50 ,  \  1E 'H' (+ 'h')
 2080 ,  \  1F 'I' (+ 'i')
 1510 ,  \  20 'J' (+ 'j')
 8648 ,  \  21 'K' (+ 'k')
 1440 ,  \  22 'L' (+ 'l')
 0578 ,  \  23 'M' (+ 'm') 
 8570 ,  \  24 'N' (+ 'n')
 1551 ,  \  25 'O' (+ 'o')
 0e51 ,  \  26 'P' (+ 'p')
 9551 ,  \  27 'Q' (+ 'q')
 8e51 ,  \  28 'R' (+ 'r')
 9021 ,  \  29 'S' (+ 's')
 2081 ,  \  2A 'T' (+ 't')
 1550 ,  \  2B 'U' (+ 'u')
 4448 ,  \  2C 'V' (+ 'v')
 c550 ,  \  2D 'W' (+ 'w')
 c028 ,  \  2E 'X' (+ 'x')
 2028 ,  \  2F 'Y' (+ 'y')
 5009 ,  \  30 'Z' (+ 'z')
 0000 ,  \  31 '[' (Not defined)
 0000 ,  \  32 '\' (Not defined)
 0000 ,  \  33 ']' (Not defined)
 0000 ,  \  34 '^' (Not defined)
 0000 ,  \  35 '_' == ascii: 5F

constant seglist \ start of lookup table.

\ finis ;tested ok 24.02.2007 19:00 mka

\ converting ASCII to LCD display segment code.
\ 14 segments form 1 digit.
\ 1 cell = 16bit = 4 nibbles = 1 digit.
\ 4 common backplanes in lcd: COM0..3

\ Segment code is:
\ L-byte bit0..3 == com0 --> segments: A,-,-,K
\ L-byte bit4..7 == com1 --> segments: J,F,H,B
\ H-byte bit0..3 == com2 --> segments: L,E,G,C
\ H-byte bit4..7 == com3 --> segments: M,P,N,D

\ example:
\ com3 com2 com1 com0 
\ 0000 1111 0101 0001  'A' 

